Skip to content

Commit 0b6b7ab

Browse files
committed
solve leetcode |830|[Positions of Large Groups]
1 parent 7e1ff35 commit 0b6b7ab

33 files changed

+433
-339
lines changed

README.md

+26-24
Large diffs are not rendered by default.

src/bitwise/gray_code.rs

+49
Original file line numberDiff line numberDiff line change
@@ -0,0 +1,49 @@
1+
/**
2+
《数字信号处理》—— 镜像反射法生成格雷码:
3+
0 1 2
4+
0 0 00
5+
1 01
6+
11
7+
10
8+
9+
先将上次迭代的结果「上下镜像复制」一份,原顺序部分在左侧加上0,镜像对称部分在左侧加上1
10+
这样能保证格雷码的要求: 从上到下仅有1bit的变化
11+
如果懂了这些背景知识,那么这题就是easy难度了,首先左侧补0的那一半可以不做(二进制左侧加0等于不变),因为原数组各项+0后还是原数组
12+
13+
```python
14+
def gray_code(n: int) -> List[int]:
15+
# 镜像反射法生成格雷码的技巧,左侧要补1的镜像部分的个数刚好等于head,而且
16+
res, head = [0], 1
17+
for _ in range(n):
18+
for i in range(head - 1, -1, -1):
19+
res.append(head + res[i])
20+
head *= 2
21+
return res
22+
```
23+
*/
24+
fn gray_code(n: i32) -> Vec<i32> {
25+
let mut res: Vec<i32> = Vec::with_capacity(2usize.pow(n as u32));
26+
res.push(0);
27+
// head表示镜像反射法生成格雷码中左侧补1需要加上的数,刚好等于镜像后的下半部分(需要左边加一个1)的个数
28+
let mut head: i32 = 1;
29+
for _ in 0..n {
30+
// 镜像对称部分在左侧加上1
31+
for i in (0..head as usize).rev() {
32+
res.push(head + res[i]);
33+
}
34+
head <<= 1;
35+
}
36+
res
37+
/* 位运算的解法?
38+
let mut res=vec![];
39+
for i in 0..1<<n{
40+
res.push(i^i>>1);
41+
}
42+
res
43+
*/
44+
}
45+
46+
#[test]
47+
fn test_gray_code() {
48+
assert_eq!(gray_code(2), vec![0b00, 0b01, 0b11, 0b10]);
49+
}

src/bitwise/mod.rs

+2-12
Original file line numberDiff line numberDiff line change
@@ -1,16 +1,6 @@
11
mod count_ones;
22
mod find_single_number;
3+
mod gray_code;
34
mod is_power_of_2;
45
mod nim_game;
5-
6-
/// https://leetcode.com/problems/reverse-bits/
7-
fn reverse_bits(mut n: u32) -> u32 {
8-
let (mut ret, mut power) = (0u32, 0u32);
9-
while n != 0 {
10-
ret += (n & 1) << power;
11-
n >>= 1;
12-
power -= 1;
13-
}
14-
ret
15-
// n.reverse_bits()
16-
}
6+
mod reverse_bits;

src/bitwise/reverse_bits.rs

+11
Original file line numberDiff line numberDiff line change
@@ -0,0 +1,11 @@
1+
/// https://leetcode.com/problems/reverse-bits/
2+
fn reverse_bits(mut n: u32) -> u32 {
3+
let (mut ret, mut power) = (0u32, 0u32);
4+
while n != 0 {
5+
ret += (n & 1) << power;
6+
n >>= 1;
7+
power -= 1;
8+
}
9+
ret
10+
// n.reverse_bits()
11+
}
File renamed without changes.

src/dp/longest_common_substr.rs

+41
Original file line numberDiff line numberDiff line change
@@ -0,0 +1,41 @@
1+
/// ## 两个字符串之间的最长公共子串
2+
/// 本算法不是leetcode的题,只是leetcode第五题的最长公共子串的解法的引申出「如何寻找两个字符串的最长公共部分」d的问题
3+
/// DP思路:如果s1[x]==s2[y]且s1[x-1]==s2[y-1],说明当前子串是公共子串
4+
fn longest_common_substr_dp(s1: String, s2: String) -> String {
5+
let (s1, s2) = (s1.into_bytes(), s2.into_bytes());
6+
let (str1_len, str2_len) = (s1.len(), s2.len());
7+
let mut max_len: usize = 0;
8+
let mut max_end_index: usize = 0;
9+
let mut dp: Vec<Vec<usize>> = vec![vec![0; str1_len]; str2_len];
10+
for x in 0..str1_len {
11+
for y in 0..str2_len {
12+
if s1[x] == s2[y] {
13+
if x == 0 || y == 0 {
14+
dp[x][y] = 1;
15+
} else {
16+
// 遍历第N行时只需用到N-1行的数据
17+
// 所以用两个1*N的数组即可,将空间复杂度从O(n^2)降低到O(2n)
18+
dp[x][y] = dp[x - 1][y - 1] + 1;
19+
}
20+
if dp[x][y] > max_len {
21+
max_len = dp[x][y];
22+
max_end_index = x;
23+
}
24+
}
25+
}
26+
}
27+
unsafe {
28+
String::from_utf8_unchecked(s1[(max_end_index - max_len + 1)..=max_end_index].to_vec())
29+
}
30+
}
31+
32+
#[test]
33+
fn test_longest_common_substr_dp() {
34+
const TEST_CASES: [(&str, &str, &str); 1] = [("caba", "abac", "aba")];
35+
for &(input1, input2, expected) in TEST_CASES.iter() {
36+
assert_eq!(
37+
longest_common_substr_dp(input1.to_string(), input2.to_string()),
38+
expected
39+
);
40+
}
41+
}

src/dp/mod.rs

+2
Original file line numberDiff line numberDiff line change
@@ -1,5 +1,7 @@
1+
mod dp_easy;
12
mod drop_eggs;
23
mod freedom_trail;
34
mod jump_game_2;
5+
mod longest_common_substr;
46
mod longest_palindromic_substr;
57
mod trapping_rain_water;

src/dp/unique_paths.rs

+75
Original file line numberDiff line numberDiff line change
@@ -0,0 +1,75 @@
1+
/** https://leetcode.com/problems/unique-paths/
2+
这题虽然以我今天的水平来看非常简单,但是由于除了DP外还有组合数解法而且还是经典题,值得单独归档成一个文件而非纳入dp_easy中
3+
4+
## DP解法
5+
本题类似70题(爬楼梯),爬到第N格梯子的路径=f(n-1)+f(n-2)
6+
由于从左下角(0,0)走到右上角(m,n)的最短路径只能往上或往右走
7+
所以得到递推式(状态转移方程):
8+
f(m,n)=f(m-1,n)+f(m,n-1)
9+
10+
### DP遍历方向
11+
初始条件:第一列和最底下的一行全为1
12+
遍历方向:从底下往上数第二行的第2个元素开始往右扫,每行是从左往右,整体是从下往上
13+
14+
## 组合数解法
15+
从(0,0)走到(m,n)总共需要走m+n步,
16+
要在m+n中选m次往右走,或者选n次往左走
17+
极致地简化了问题,将问题抽象成组合数问题
18+
组合问题(要从班上m+n个同学中选m个做值日,或者选n个不做值日)
19+
知识补充:排列问题(从班上m+n个同学中列出田径100米赛跑前3名的可能情况)
20+
21+
> return math.comb(m-1 + n-1, n-1) if m > n else math.comb(n-1 + m-1, m-1)
22+
23+
```go
24+
func UniquePaths(m int, n int) int {
25+
// 端点是4x4,但是棋盘的格子就3x3
26+
max, min := m-1, n-1
27+
if min > max {
28+
max, min = min, max
29+
}
30+
result := 1
31+
sum := max+min
32+
for i:=0; i<min; i++ {
33+
result *= sum-i
34+
// 先乘后除,避免result溢出
35+
result /= i+1
36+
}
37+
return result
38+
}
39+
```
40+
41+
### 组合数解法int溢出问题
42+
在Go语言中,遍历计算组合数时先乘后除不会溢出,而在Rust中即便用了u32类型也会在(52,9)这个测试用例上溢出
43+
我在本题采用了u64类型,也算避免了溢出
44+
关于能否整除的问题,我试了下,如果分子的阶乘是从大到小,分母的阶乘是从小到大,大概率不会溢出
45+
46+
### 端点与格子的问题
47+
由于输入的m、n表示的是端点数(联想围棋的点)
48+
但是走路的方式却是在网格上走,所以实际的m和n应该是m-1和n-1
49+
50+
## 参看
51+
[走格子/棋盘问题 有多少条路径可走](https://blog.csdn.net/yusiguyuan/article/details/12875415)
52+
*/
53+
fn unique_paths(m: i32, n: i32) -> i32 {
54+
let m: u64 = (m - 1) as u64;
55+
let mut n: u64 = (n - 1) as u64;
56+
let mut res: u64 = 1;
57+
let sum: u64 = m + n;
58+
if n > m {
59+
n = m;
60+
}
61+
// Example: 组合数C(5,2)=5*4/1*2
62+
for i in 0..n {
63+
res *= sum - i;
64+
res /= i + 1;
65+
}
66+
res as i32
67+
}
68+
69+
#[test]
70+
fn test_unique_paths() {
71+
const TEST_CASES: [(i32, i32, i32); 2] = [(23, 12, 193536720), (51, 9, 1916797311)];
72+
for &(m, n, expected) in TEST_CASES.iter() {
73+
assert_eq!(unique_paths(m, n), expected);
74+
}
75+
}
Original file line numberDiff line numberDiff line change
@@ -1,19 +1,15 @@
1-
struct Solution;
2-
3-
impl Solution {
4-
fn find_numbers(nums: Vec<i32>) -> i32 {
5-
let mut res = 0;
6-
for num in nums {
7-
let mut n = num;
8-
let mut digit_count = 0;
9-
while n != 0 {
10-
n /= 10;
11-
digit_count += 1;
12-
}
13-
if digit_count % 2 == 0 {
14-
res += 1;
15-
}
1+
fn find_numbers(nums: Vec<i32>) -> i32 {
2+
let mut res = 0;
3+
for num in nums {
4+
let mut n = num;
5+
let mut digit_count = 0;
6+
while n != 0 {
7+
n /= 10;
8+
digit_count += 1;
9+
}
10+
if digit_count % 2 == 0 {
11+
res += 1;
1612
}
17-
res
1813
}
14+
res
1915
}

src/easy/array/gray_code.rs

-42
This file was deleted.

src/easy/array/mod.rs

-1
Original file line numberDiff line numberDiff line change
@@ -1,6 +1,5 @@
11
mod count_good_triplets;
22
mod find_numbers_with_even_number_of_digits;
3-
mod gray_code;
43
mod partition_array;
54
mod queries_on_a_permutation_with_key;
65
mod squares_of_a_sorted_array;

src/easy/backspace_string_compare.rs

+31
Original file line numberDiff line numberDiff line change
@@ -0,0 +1,31 @@
1+
/// '#'表示退格操作,请你比较两个含退格操作符的字符串是否相等
2+
fn backspace_compare(s: String, t: String) -> bool {
3+
fn parse(s: String) -> Vec<u8> {
4+
let mut ret: Vec<u8> = Vec::new();
5+
for byte in s.into_bytes() {
6+
if byte == b'#' {
7+
let _ = ret.pop();
8+
} else {
9+
ret.push(byte);
10+
}
11+
}
12+
ret
13+
}
14+
parse(s) == parse(t)
15+
}
16+
17+
#[test]
18+
fn test_backspace_compare() {
19+
const TEST_CASES: [(&str, &str, bool); 4] = [
20+
("ab#c", "ad#c", true),
21+
("ab##", "c#d#", true),
22+
("a##c", "#a#c", true),
23+
("a#c", "b", false),
24+
];
25+
for &(s, t, expected) in &TEST_CASES {
26+
assert_eq!(
27+
Solution::backspace_compare(s.to_string(), t.to_string()),
28+
expected
29+
);
30+
}
31+
}

src/easy/counter.rs

+3-3
Original file line numberDiff line numberDiff line change
@@ -5,7 +5,7 @@ count if nums[i] == nums[j] and i < j
55
思路: collection.Counter统计输入数组每个数字的出现次数,例如3出现了3次,那么就有math.comb(3,2)=3*2=6对满足i<j且nums[i]==nums[j]
66
77
除了Counter,还有已知输入全小写字母字符串需要一些记忆操作例如最长无重复子串,也建议用固定长数组,下标寻址比HashMap快
8-
> return sum(map(lambda v: math.comb(v, 2), collections.Counter(nums).values()))
8+
> return sum(map(lambda v: math_or_puzzle_game.comb(v, 2), collections.Counter(nums).values()))
99
*/
1010
fn num_identical_pairs(nums: Vec<i32>) -> i32 {
1111
let mut counter = [0u8; 101];
@@ -243,7 +243,7 @@ fn count_pairs_permutation_solution(nums: Vec<i32>) -> i32 {
243243
for j in i..n {
244244
if is_power_of_2(unique[i] + unique[j]) {
245245
if i == j {
246-
// math.comb(count, 2)
246+
// math_or_puzzle_game.comb(count, 2)
247247
ret += (counter[i] - 1) * counter[i] / 2;
248248
} else {
249249
ret += counter[i] * counter[j];
@@ -282,7 +282,7 @@ fn test_gen_twos_geometric_series() {
282282
println!("{:?}", gen_twos_geometric_series::<22>());
283283
}
284284

285-
/// 这个解法也就是把时间复杂度从O(n^2)降低到O(22n
285+
/// 这个解法也就是把时间复杂度从O(n^2)降低到O(22n
286286
fn count_pairs_two_sum_solution(nums: Vec<i32>) -> i32 {
287287
// 照顾下leetcode.com的const fn不支持while loop
288288
// const TWO_SUMS: [i32; 22] = [1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048, 4096, 8192, 16384, 32768, 65536, 131072, 262144, 524288, 1048576, 2097152];

src/easy/majority_element.rs

-40
This file was deleted.

0 commit comments

Comments
 (0)